#ifndef	__SCREENFX_H
#define	__SCREENFX_H

/*

   SCREENFX.H

      ScreenFX v1.1.0 18th Nov 97
      Written for DJGPP+Allegro
      Copyright (C)1997, Brett Porter

*/

#include <allegro.h>

#ifdef   __cplusplus
extern "C" {
#endif

int   pInitialise();

void  pRandomize( void );
int   pRandom( int aMax );

void  pWipeLeftToRight( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeRightToLeft( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeTopToBottom( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeBottomToTop( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeToCentreVertically( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeFromCentreVertically( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeToCentreHorizontally( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pWipeFromCentreHorizontally( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pBleed( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aDropletWidth, int aMasked );
void  pDrain( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pOverwriteZap( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed, int aMasked );
void  pPushZap( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed );
void  pSplitZapSmall( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed );
void  pSplitZapFull( int aXPos, int aYPos, BITMAP *aBitmap, int aSpeed );
void  pShake( int aXPos, int aYPos, BITMAP *aBitmap, int aMaxShake, int aNumShake, int aSpeed, int aMasked );
void  pSpiralIn( int aXPos, int aYPos, BITMAP *aBitmap, int aSpiralWidth, int aSpeed, int aMasked );
void  pSpiralOut( int aXPos, int aYPos, BITMAP *aBitmap, int aSpiralWidth, int aSpeed, int aMasked );
void  pFlag( int aXPos, int aYPos, BITMAP *aBitmap, fixed aAmps, fixed aComp, int aWaves, int aSpeed, int aMasked );

#ifdef   __cplusplus
} /* extern "C" */
#endif

#endif


