#include <assert.h>
#include <conio.h>
#include <stdio.h>

#include "screenfx.h"
#include "test.h"

/*

   TESTPROG.C

      Test program for ScreenFX routine set

      ScreenFX v1.1.0 18th Nov 97
      Written for DJGPP+Allegro
      Copyright (C)1997, Brett Porter

*/

int	main()
{
	BITMAP	*lBitmap1, *lBitmap2, *lFrameBitmap, *lFlagBitmap;
	PALETTE	*lPalette;
	DATAFILE *lDataFile;
   int      lCentreX, lCentreY;

   lDataFile = load_datafile( "test.dat" );
	if ( lDataFile == NULL )
	{
		printf( "Couldn't load the datafile...\n\n" );
		return -1;
	}

   if ( !pInitialise())
	{
		printf( "Invalid video mode...\n\n" );
      return -1;
	}

	lFlagBitmap = create_bitmap( SCREEN_W, SCREEN_H );
	clear( lFlagBitmap );
	stretch_sprite( lFlagBitmap, lDataFile[Flag].dat, 0, 0, SCREEN_W, SCREEN_H-20 );

	lBitmap1 = create_bitmap( SCREEN_W, SCREEN_H );
	clear( lBitmap1 );
	stretch_sprite( lBitmap1, lDataFile[Frame1].dat, 0, 0, SCREEN_W, SCREEN_H );

	lBitmap2 = create_bitmap( SCREEN_W, SCREEN_H );
	clear( lBitmap2 );
	stretch_sprite( lBitmap2, lDataFile[Frame2].dat, 0, 0, SCREEN_W, SCREEN_H );

	lFrameBitmap =	lDataFile[PorterSprite].dat;
	lPalette = lDataFile[GlobalPalette].dat;

	set_palette( black_palette );
	clear( screen );
	blit(	lFlagBitmap, screen, 0, 0, 0, 20, SCREEN_W, SCREEN_H-20 );
	fade_in( *lPalette, 1 );
	pFlag( 0, 0, lFlagBitmap, itofix( 10 ), ftofix( 0.05 ), 25, 0, FALSE );
	fade_out( 1 );
	blit( lBitmap1, screen, 0, 0, 0, 0, lBitmap1->w, lBitmap1->h );
	set_palette( *lPalette );
   cprintf( "\x7" );
	getch();
	pShake( 0, 0, lBitmap1, 10, 20, 100, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeLeftToRight( 0, 0, lBitmap2, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeRightToLeft( 0, 0, lBitmap1, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeTopToBottom( 0, 0, lBitmap2, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeBottomToTop( 0, 0, lBitmap1, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeToCentreVertically( 0, 0, lBitmap2, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeFromCentreVertically( 0, 0, lBitmap1, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeToCentreHorizontally( 0, 0, lBitmap2, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pWipeFromCentreHorizontally( 0, 0, lBitmap1, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pPushZap( 0, 0, lBitmap2, 8 );
   cprintf( "\x7" );
	getch();
	pBleed( 0, 0, lBitmap1, 10, 2, FALSE );
   cprintf( "\x7" );
	getch();
	pOverwriteZap( 0, 0, lBitmap2, 1, FALSE );
   cprintf( "\x7" );
	getch();
	pSpiralIn( 0, 0, lBitmap1, 10, 5, FALSE );
   cprintf( "\x7" );
	getch();
	pSpiralOut( 0, 0, lBitmap2, 10, 5, FALSE );
   cprintf( "\x7" );
	getch();
	lCentreX = ( SCREEN_W-lFrameBitmap->w )/2;
	lCentreY = ( SCREEN_H-lFrameBitmap->h )/2;
	pDrain( lCentreX, lCentreY, lFrameBitmap, 10, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap1->w, lBitmap1->h );
	pSplitZapSmall( lCentreX, lCentreY, lFrameBitmap, 10 );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pSplitZapFull( lCentreX, lCentreY, lFrameBitmap, 10 );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pShake( lCentreX, lCentreY, lFrameBitmap, 10, 20, 100, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pFlag( lCentreX, lCentreY, lFrameBitmap, itofix( 10 ), ftofix( 0.05 ), 25, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeLeftToRight( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeRightToLeft( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeTopToBottom( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeBottomToTop( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeToCentreVertically( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeFromCentreVertically( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeToCentreHorizontally( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pWipeFromCentreHorizontally( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pPushZap( lCentreX, lCentreY, lFrameBitmap, 1 );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pBleed( lCentreX, lCentreY, lFrameBitmap, 50, 1, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pOverwriteZap( lCentreX, lCentreY, lFrameBitmap, 5, TRUE );
   cprintf( "\x7" );
	getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pSpiralIn( lCentreX, lCentreY, lFrameBitmap, 10, 5, TRUE );
   cprintf( "\x7" );
   getch();
	blit( lBitmap2, screen, 0, 0, 0, 0, lBitmap2->w, lBitmap2->h );
	pSpiralOut( lCentreX, lCentreY, lFrameBitmap, 10, 5, TRUE );
   cprintf( "\x7" );
	getch();
	unload_datafile( lDataFile );
	return 0;
}

